#ifndef GAMEMANAGER_H
#define GAMEMANAGER_H
#include <QString>
#include <QVector>
#include <QFile>
#include <QDir>
#include <QStringList>
#include <QProcess>
#include "mod.h"
#include "savedgame.h"
#include "settings.h"
#include "modprofile.h"

class GameManager
{
public:
    GameManager();
    QString findWarzone();
    QString findDataPath();
    QString findModPath();
    bool validBinaryPath();
    QVector<class Mod> getAvailableMods();
    QVector<class SavedGame> getSavedGames();
    void startGame(ModProfile p);
    void loadAvailableMods();
private:
    QVector<class Mod> availableMods;
    QVector<class SavedGame> savedGames;

};

#endif // GAMEMANAGER_H
