#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include <QCloseEvent>
#include <QMessageBox>
#include <QDesktopServices>
#include <QUrl>
#include <QDir>
#include "modprofilewindow.h"
#include "settingsdialog.h"
#include "settings.h"
#include "gamemanager.h"
#include "creditsdialog.h"

namespace Ui
{
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    Ui::MainWindow *ui;
    void init();
    void showSettings();

private slots:
    void on_pushButton_clicked();
    void on_exitButton_clicked();
    void on_websiteButton_clicked();
    void on_modButton_clicked();
    void on_settingsButton_clicked();
    void on_startGameButton_clicked();
};

#endif // MAINWINDOW_H
