#ifndef MODORDERWINDOW_H
#define MODORDERWINDOW_H

#include <QtGui/QDialog>
#include <QVector>
#include "modprofile.h"
#include "mod.h"
#include "settings.h"

namespace Ui {
    class ModOrderWindow;
}

class ModOrderWindow : public QDialog {
    Q_OBJECT
public:
    ModOrderWindow(QWidget *parent = 0);
    ~ModOrderWindow();
    void setProfile(ModProfile profile);
    QVector<class Mod> mods;


protected:
    void changeEvent(QEvent *e);

private:
    Ui::ModOrderWindow *m_ui;
    ModProfile currentProfile;
    void updateOrder();

private slots:
    void on_applyButton_clicked();
    void on_okButton_clicked();
    void on_moveDownButton_clicked();
    void on_moveUpButton_clicked();
    void on_cancelButton_clicked();
};

#endif // MODORDERWINDOW_H
