#ifndef SETTINGS_H
#define SETTINGS_H
#include <QApplication>
#include <QString>
#include <QFile>
#include <QVector>
#include <QDomDocument>
#include <QDomElement>
#include <QDomText>
#include "modprofile.h"
#include "mod.h"
#include "gamemanager.h"
#include <QTextStream>

class Settings
{
public:
    Settings();
    bool loadSettings();
    bool saveSettings();
    void removeProfile(QString profileName);
    ModProfile getProfile(QString profileName);
    void updateProfile(ModProfile profile);
    static QString warzonePath;
    static QString dataPath;
    static QString modPath;
    static QVector<class ModProfile> modProfiles;
    static QString selectedProfile;

    static bool dataDirEnabled;
    static QString dataDir;
    static bool configDirEnabled;
    static QString configDir;
    static bool gameTypeEnabled;
    static QString gameType;
    static bool savedGameEnabled;
    static QString savedGame;
    static bool cheatsEnabled;
    static bool hostScreen;
    static bool joinMPEnabled;
    static QString hostName;

    static bool fullscreen;
    static bool shadows;
    static bool resolutionEnabled;
    static int width;
    static int height;
    static bool sound;

    static bool logFileEnabled;
    static QString logFile;
    static bool debugAll;
    static bool debugMain;
    static bool debugSound;
    static bool debugWZ;
    static bool debug3D;
    static bool debugTexture;
    static bool debugMemory;
    static bool debugScript;
    static bool debugVideo;
    static bool debugNet;
    static bool debugError;
    static bool disableAsserts;
    static bool selfTest;
    static bool crash;
    static bool flushDebug;


private:

};

#endif // SETTINGS_H
