#include "settingsdialog.h"
#include "ui_settingsdialog.h"

SettingsDialog::SettingsDialog(QWidget *parent) :
    QDialog(parent),
    m_ui(new Ui::SettingsDialog)
{
    m_ui->setupUi(this);
    init();
}

SettingsDialog::~SettingsDialog()
{
    delete m_ui;
}

void SettingsDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void SettingsDialog::on_chkDataDir_clicked()
{
    if(m_ui->chkDataDir->isChecked()){
        m_ui->txtDataDir->setEnabled(true);
        m_ui->btnBrowseData->setEnabled(true);
    }
    else{
        m_ui->txtDataDir->setEnabled(false);
        m_ui->btnBrowseData->setEnabled(false);
    }
}

void SettingsDialog::on_chkConfigDir_clicked()
{
    if(m_ui->chkConfigDir->isChecked()){
        m_ui->txtConfigDir->setEnabled(true);
        m_ui->btnBrowseConfig->setEnabled(true);
    }
    else{
        m_ui->txtConfigDir->setEnabled(false);
        m_ui->btnBrowseConfig->setEnabled(false);
    }
}

void SettingsDialog::on_chkGame_clicked()
{
    if(m_ui->chkGame->isChecked()){
        m_ui->cboGame->setEnabled(true);
    }
    else{
        m_ui->cboGame->setEnabled(false);
    }
}

void SettingsDialog::on_chkSavedGame_clicked()
{
    if(m_ui->chkSavedGame->isChecked()){
        m_ui->cboSavedGame->setEnabled(true);
    }
    else{
        m_ui->cboSavedGame->setEnabled(false);
    }
}

void SettingsDialog::on_chkJoin_clicked()
{
    if(m_ui->chkJoin->isChecked()){
        m_ui->txtHostName->setEnabled(true);
    }
    else{
        m_ui->txtHostName->setEnabled(false);
    }
}

void SettingsDialog::on_chkResolution_clicked()
{
    if(m_ui->chkResolution->isChecked()){
        m_ui->txtWidth->setEnabled(true);
        m_ui->txtHeight->setEnabled(true);
    }
    else{
        m_ui->txtWidth->setEnabled(false);
        m_ui->txtHeight->setEnabled(false);
    }
}

void SettingsDialog::on_chkDebugLogFile_clicked()
{
    if(m_ui->chkDebugLogFile->isChecked()){
        m_ui->txtDebugLogFile->setEnabled(true);
        m_ui->btnBrowseLogFile->setEnabled(true);
    }
    else{
        m_ui->txtWidth->setEnabled(false);
        m_ui->btnBrowseLogFile->setEnabled(false);
    }
}

void SettingsDialog::on_chkDebugAll_clicked()
{
    if(m_ui->chkDebugAll->isChecked()){
        m_ui->chkDebug3D->setEnabled(false);
        m_ui->chkDebugError->setEnabled(false);
        m_ui->chkDebugMain->setEnabled(false);
        m_ui->chkDebugMemory->setEnabled(false);
        m_ui->chkDebugNet->setEnabled(false);
        m_ui->chkDebugScript->setEnabled(false);
        m_ui->chkDebugSound->setEnabled(false);
        m_ui->chkDebugTexture->setEnabled(false);
        m_ui->chkDebugVideo->setEnabled(false);
        m_ui->chkDebugWZ->setEnabled(false);
    }
    else{
        m_ui->chkDebug3D->setEnabled(true);
        m_ui->chkDebugError->setEnabled(true);
        m_ui->chkDebugMain->setEnabled(true);
        m_ui->chkDebugMemory->setEnabled(true);
        m_ui->chkDebugNet->setEnabled(true);
        m_ui->chkDebugScript->setEnabled(true);
        m_ui->chkDebugSound->setEnabled(true);
        m_ui->chkDebugTexture->setEnabled(true);
        m_ui->chkDebugVideo->setEnabled(true);
        m_ui->chkDebugWZ->setEnabled(true);
    }
}

void SettingsDialog::on_cancelButton_clicked()
{
    this->reject();
}

void SettingsDialog::on_okButton_clicked()
{
    saveSettings();
    this->accept();
}

void SettingsDialog::on_applyButton_clicked()
{
    saveSettings();
}

void SettingsDialog::saveSettings(){
    Settings::warzonePath = m_ui->txtWZExecutable->text();
    Settings::dataDirEnabled = m_ui->chkDataDir->isChecked();
    Settings::dataDir = m_ui->txtDataDir->text();
    Settings::configDirEnabled = m_ui->chkConfigDir->isChecked();
    Settings::configDir = m_ui->txtConfigDir->text();
    Settings::gameTypeEnabled = m_ui->chkGame->isChecked();
    Settings::gameType = m_ui->cboGame->currentText();
    Settings::savedGameEnabled = m_ui->chkSavedGame->isChecked();
    Settings::savedGame = m_ui->cboSavedGame->currentText();
    Settings::cheatsEnabled = m_ui->chkCheats->isChecked();
    Settings::hostScreen = m_ui->chkHost->isChecked();
    Settings::joinMPEnabled = m_ui->chkJoin->isChecked();
    Settings::hostName = m_ui->txtHostName->text();

    Settings::fullscreen = m_ui->chkFullScreen->isChecked();
    Settings::shadows = m_ui->chkShadows->isChecked();
    Settings::resolutionEnabled = m_ui->chkResolution->isChecked();
    Settings::sound = m_ui->chkSound->isChecked();

    Settings::logFileEnabled = m_ui->chkDebugLogFile->isChecked();
    Settings::logFile = m_ui->txtDebugLogFile->text();
    Settings::disableAsserts = m_ui->chkDisableAsserts->isChecked();
    Settings::selfTest = m_ui->chkSelfTest->isChecked();
    Settings::crash = m_ui->chkCrash->isChecked();

    Settings::debugAll = m_ui->chkDebugAll->isChecked();
    Settings::debug3D = m_ui->chkDebug3D->isChecked();
    Settings::debugError = m_ui->chkDebugError->isChecked();
    Settings::debugMain = m_ui->chkDebugMain->isChecked();
    Settings::debugMemory = m_ui->chkDebugMemory->isChecked();
    Settings::debugNet = m_ui->chkDebugNet->isChecked();
    Settings::debugScript = m_ui->chkDebugScript->isChecked();
    Settings::debugSound = m_ui->chkDebugSound->isChecked();
    Settings::debugTexture = m_ui->chkDebugTexture->isChecked();
    Settings::debugVideo = m_ui->chkDebugVideo->isChecked();
    Settings::debugWZ = m_ui->chkDebugWZ->isChecked();
    Settings::flushDebug = m_ui->chkFlushDebug->isChecked();
    Settings::width = m_ui->txtWidth->text().toInt();
    Settings::height = m_ui->txtHeight->text().toInt();

}
void SettingsDialog::loadSettings(){
    m_ui->txtWZExecutable->setText(Settings::warzonePath);
    m_ui->chkDataDir->setChecked(Settings::dataDirEnabled);
    m_ui->txtDataDir->setText(Settings::dataDir);
    m_ui->chkConfigDir->setChecked(Settings::configDirEnabled);
    m_ui->txtConfigDir->setText(Settings::configDir);
    m_ui->chkGame->setChecked(Settings::gameTypeEnabled);
    m_ui->cboSavedGame->setCurrentIndex(m_ui->cboSavedGame->findText(Settings::savedGame));
    m_ui->cboGame->setCurrentIndex(m_ui->cboGame->findText(Settings::gameType));
    m_ui->chkSavedGame->setChecked(Settings::savedGameEnabled);
    m_ui->chkCheats->setChecked(Settings::cheatsEnabled);
    m_ui->chkHost->setChecked(Settings::hostScreen);
    m_ui->chkJoin->setChecked(Settings::joinMPEnabled);
    m_ui->txtHostName->setText(Settings::hostName);
    m_ui->chkFullScreen->setChecked(Settings::fullscreen);
    m_ui->chkShadows->setChecked(Settings::shadows);
    m_ui->chkResolution->setChecked(Settings::resolutionEnabled);
    m_ui->chkSound->setChecked(Settings::sound);
    m_ui->chkDebugLogFile->setChecked(Settings::logFileEnabled);
    m_ui->txtDebugLogFile->setText(Settings::logFile);
    m_ui->chkDisableAsserts->setChecked(Settings::disableAsserts);
    m_ui->chkSelfTest->setChecked(Settings::selfTest);
    m_ui->chkCrash->setChecked(Settings::crash);
    m_ui->chkDebugAll->setChecked(Settings::debugAll);
    m_ui->chkDebug3D->setChecked(Settings::debug3D);
    m_ui->chkDebugError->setChecked(Settings::debugError);
    m_ui->chkDebugMain->setChecked(Settings::debugMain);
    m_ui->chkDebugMemory->setChecked(Settings::debugMemory);
    m_ui->chkDebugNet->setChecked(Settings::debugNet);
    m_ui->chkDebugScript->setChecked(Settings::debugScript);
    m_ui->chkDebugSound->setChecked(Settings::debugSound);
    m_ui->chkDebugTexture->setChecked(Settings::debugTexture);
    m_ui->chkDebugVideo->setChecked(Settings::debugVideo);
    m_ui->chkDebugWZ->setChecked(Settings::debugWZ);
    m_ui->chkFlushDebug->setChecked(Settings::flushDebug);

    QString value;
    value.setNum(Settings::width);
    m_ui->txtWidth->setText(value);
    value.setNum(Settings::height);
    m_ui->txtHeight->setText(value);


    if(m_ui->chkDebugAll->isChecked()){
        m_ui->chkDebug3D->setEnabled(false);
        m_ui->chkDebugError->setEnabled(false);
        m_ui->chkDebugMain->setEnabled(false);
        m_ui->chkDebugMemory->setEnabled(false);
        m_ui->chkDebugNet->setEnabled(false);
        m_ui->chkDebugScript->setEnabled(false);
        m_ui->chkDebugSound->setEnabled(false);
        m_ui->chkDebugTexture->setEnabled(false);
        m_ui->chkDebugVideo->setEnabled(false);
        m_ui->chkDebugWZ->setEnabled(false);
    }
    else{
        m_ui->chkDebug3D->setEnabled(true);
        m_ui->chkDebugError->setEnabled(true);
        m_ui->chkDebugMain->setEnabled(true);
        m_ui->chkDebugMemory->setEnabled(true);
        m_ui->chkDebugNet->setEnabled(true);
        m_ui->chkDebugScript->setEnabled(true);
        m_ui->chkDebugSound->setEnabled(true);
        m_ui->chkDebugTexture->setEnabled(true);
        m_ui->chkDebugVideo->setEnabled(true);
        m_ui->chkDebugWZ->setEnabled(true);
    }
    if(m_ui->chkResolution->isChecked()){
        m_ui->txtWidth->setEnabled(true);
        m_ui->txtHeight->setEnabled(true);
    }

    if(m_ui->chkJoin->isChecked()){
        m_ui->txtHostName->setEnabled(true);
    }

    if(m_ui->chkDebugLogFile->isChecked()){
        m_ui->txtDebugLogFile->setEnabled(true);
        m_ui->btnBrowseLogFile->setEnabled(true);
    }

    if(m_ui->chkSavedGame->isChecked()){
        m_ui->cboSavedGame->setEnabled(true);
    }

    if(m_ui->chkGame->isChecked()){
        m_ui->cboGame->setEnabled(true);
    }

    if(m_ui->chkDataDir->isChecked()){
        m_ui->txtDataDir->setEnabled(true);
        m_ui->btnBrowseData->setEnabled(true);
    }

    if(m_ui->chkConfigDir->isChecked()){
        m_ui->txtConfigDir->setEnabled(true);
        m_ui->btnBrowseConfig->setEnabled(true);
    }


}
void SettingsDialog::loadSavedGames(){
    QStringList filter;
    filter << "*.gam";


    QDir dir = QDir(Settings::dataPath + "/savegame");

    QStringList savedGames = dir.entryList(filter,QDir::Files,QDir::NoSort);

    for(int index = 0;index < savedGames.size();index++) {
        QString savedGame = savedGames.at(index);
        m_ui->cboSavedGame->addItem(savedGame.left(savedGame.lastIndexOf(".")));
    }
}
void SettingsDialog::init(){
    loadSavedGames();
    loadSettings();
}

void SettingsDialog::on_btnBrowseExec_clicked()
{
    QFileDialog *dia = new QFileDialog(this,Qt::Dialog);
    QStringList filters;

    #ifdef Q_OS_WIN
        filters << "EXE Files (*.exe)" << "Any files (*)";
    #endif

    #ifdef Q_OS_MAC
        filters << "Applications (*.app)"<< "Any files (*)";
    #endif

    #ifdef Q_OS_LINUX
        filters << "Any files (*)";
    #endif

    dia->setNameFilters(filters);
    dia->setDirectory(this->m_ui->txtWZExecutable->text());
    switch(dia->exec()) {
        case QFileDialog::Accepted:
            this->m_ui->txtWZExecutable->setText(dia->selectedFiles().first());
            break;
    }
    delete dia;
}

void SettingsDialog::on_btnBrowseData_clicked()
{
    QFileDialog *dia = new QFileDialog(this,Qt::Dialog);
    dia->setFileMode(QFileDialog::DirectoryOnly);
    dia->setDirectory(this->m_ui->txtDataDir->text());
    switch(dia->exec()) {
        case QFileDialog::Accepted:
            this->m_ui->txtDataDir->setText(dia->selectedFiles().first());
            break;
    }
    delete dia;
}

void SettingsDialog::on_btnBrowseConfig_clicked()
{
    QFileDialog *dia = new QFileDialog(this,Qt::Dialog);
    dia->setFileMode(QFileDialog::DirectoryOnly);
    dia->setDirectory(this->m_ui->txtConfigDir->text());
    switch(dia->exec()) {
        case QFileDialog::Accepted:
            this->m_ui->txtConfigDir->setText(dia->selectedFiles().first());
            break;
    }
    delete dia;
}

void SettingsDialog::on_btnBrowseLogFile_clicked()
{
    QFileDialog *saveFile = new QFileDialog(this,Qt::Dialog);
    saveFile->setAcceptMode(QFileDialog::AcceptSave);
    QStringList filters;
    filters << "Any files (*)";

    saveFile->setNameFilters(filters);

    switch(saveFile->exec()){
    case QFileDialog::Accepted:
        m_ui->txtDebugLogFile->setText(saveFile->selectedFiles().first());
        break;
    }
    delete saveFile;
}
