#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H

#include <QtGui/QDialog>
#include <QFileDialog>
#include "settings.h"
#include <QTextStream>

namespace Ui {
    class SettingsDialog;
}

class SettingsDialog : public QDialog {
    Q_OBJECT
public:
    SettingsDialog(QWidget *parent = 0);
    ~SettingsDialog();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::SettingsDialog *m_ui;
    void saveSettings();
    void loadSettings();
    void loadSavedGames();
    void init();

private slots:
    void on_btnBrowseLogFile_clicked();
    void on_btnBrowseConfig_clicked();
    void on_btnBrowseData_clicked();
    void on_btnBrowseExec_clicked();
    void on_applyButton_clicked();
    void on_okButton_clicked();
    void on_cancelButton_clicked();
    void on_chkDebugAll_clicked();
    void on_chkDebugLogFile_clicked();
    void on_chkResolution_clicked();
    void on_chkJoin_clicked();
    void on_chkSavedGame_clicked();
    void on_chkGame_clicked();
    void on_chkConfigDir_clicked();
    void on_chkDataDir_clicked();
};

#endif // SETTINGSDIALOG_H
